/*
 * Copyright 2013 Yuichiro Moriguchi
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package net.morilib.awk.pattern;

import net.morilib.awk.io.AwkFiles;
import net.morilib.awk.namespace.AwkNamespace;

public class AwkAndPattern implements AwkPattern {

	private AwkPattern e1, e2;

	public AwkAndPattern(AwkPattern e1, AwkPattern e2) {
		this.e1 = e1;
		this.e2 = e2;
	}

	public boolean isBegin() {
		return false;
	}

	public boolean isEnd() {
		return false;
	}

	public AwkMatchState match(AwkNamespace ns, AwkFiles fs,
			String s, AwkMatchState stat) {
		boolean e, f;

		e = !e1.match(ns, fs, s, stat).isNotMatched();
		f = !e2.match(ns, fs, s, stat).isNotMatched();
		return  e && f ?
				AwkMatchState.MATCHED : AwkMatchState.NO_MATCH;
	}

	public boolean isRanged() {
		return false;
	}

}
